export interface FramePrepareCallback {
    (frame: number, framesForWarmup: number, framesPerRun: number, cycle: number): void;
}
export interface RunsFinishedCallback {
    (cycles: number, framesForWarmup: number, framesPerRun: number, results: Array<number>): void;
}
export declare class Benchmark {
    protected _running: boolean;
    protected _results: Array<number>;
    protected _frames: number;
    protected _runs: number;
    protected _framesPerCycle: number;
    protected _framesForWarmup: number;
    protected _framePrepare: FramePrepareCallback | undefined;
    protected _runsFinished: RunsFinishedCallback | undefined;
    initialize(cycles: number, framesForWarmup: number, framesPerRun: number, framePrepare: FramePrepareCallback, runsFinished: RunsFinishedCallback): void;
    frame(): void;
    get running(): boolean;
}
